summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--app/xterm/KOI8RXTerm.ad20
-rw-r--r--app/xterm/koi8rxterm84
-rw-r--r--app/xterm/koi8rxterm.man97
-rw-r--r--app/xterm/uxterm.man91
4 files changed, 292 insertions, 0 deletions
diff --git a/app/xterm/KOI8RXTerm.ad b/app/xterm/KOI8RXTerm.ad
new file mode 100644
index 000000000..aa21f2666
--- /dev/null
+++ b/app/xterm/KOI8RXTerm.ad
@@ -0,0 +1,20 @@
+! $XTermId: KOI8RXTerm.ad,v 1.2 2007/12/30 15:49:14 tom Exp $
+
+! This is based on the UXTerm app-defaults file.
+
+! Use
+! xterm -class KOI8RXTerm
+! to set resources for KOI8-R mode with corresponding fonts.
+
+#include "XTerm-color"
+
+*fontMenu.Label: KOI8-R Fonts
+*VT100*allowC1Printable: true
+
+! Use Cyrillic instead of Latin fonts.
+*VT100.font: -misc-fixed-medium-r-semicondensed--13-120-75-75-c-60-koi8-r
+*VT100.font2: -misc-fixed-medium-r-normal--8-80-75-75-c-50-koi8-r
+*VT100.font3: -misc-fixed-medium-r-normal--14-130-75-75-c-70-koi8-r
+*VT100.font4: -misc-fixed-medium-r-normal--13-120-75-75-c-80-koi8-r
+*VT100.font5: -misc-fixed-medium-r-normal--18-120-100-100-c-90-koi8-r
+*VT100.font6: -misc-fixed-medium-r-normal--20-200-75-75-c-100-koi8-r
diff --git a/app/xterm/koi8rxterm b/app/xterm/koi8rxterm
new file mode 100644
index 000000000..ee9a242b9
--- /dev/null
+++ b/app/xterm/koi8rxterm
@@ -0,0 +1,84 @@
+#!/bin/sh
+# $XTermId: koi8rxterm,v 1.3 2007/12/30 16:33:06 tom Exp $
+# This is a wrapper script to set up xterm with a KOI8-R locale; based on
+# uxterm.
+
+whoami=koi8rxterm
+
+: ${XTERM_PROGRAM=xterm}
+
+# Check if there is a workable locale program. If there is not, we will read
+# something via the standard error. Ignore whatever is written to the
+# standard output.
+locale=`sh -c "LC_ALL=C LC_CTYPE=C LANG=C locale >/dev/null" 2>&1`
+found=no
+
+# Check for -version and -help options, to provide a simple return without
+# requiring the program to create a window:
+if test $# = 1
+then
+ case $1 in
+ -v|-ver*|-h|-he*)
+ $XTERM_PROGRAM "$@"
+ exit $?
+ ;;
+ esac
+fi
+
+# Check environment variables that xterm does, in the same order:
+for name in LC_ALL LC_CTYPE LANG
+do
+ eval 'value=$'$name
+ if test -n "$value" ; then
+ case $value in
+ *.koi8r|*.KOI8R|*.koi8-r|*.KOI8-R)
+ found=yes
+ ;;
+ *.koi8r@*|*.KOI8R@*|*.koi8-r@*|*.KOI8-R*)
+ found=yes
+ ;;
+ *)
+ # The user may not have configured his or her
+ # locale; try to muddle through anyway.
+ value=ru_RU.KOI8-R
+ ;;
+ esac
+ break
+ fi
+done
+
+# If we didn't find one that uses KOI8-R, modify the safest one. Not everyone
+# has a KOI8-R locale installed (and there appears to be no trivial/portable
+# way to determine whether it is, from a shell script). We could check if the
+# user's shell does not reset unknown locale specifiers, but not all shells do.
+if test $found != yes ; then
+ if test -n "$value" ; then
+ value=`echo ${value} |sed -e 's/[.@].*//'`.KOI8-R
+ else
+ name="LC_CTYPE"
+ value="ru_RU.KOI8-R"
+ fi
+ eval save=\$${name}
+ eval ${name}=${value}
+ eval export ${name}
+ if test -z "$locale" ; then
+ # The 'locale' program tries to do a sanity check.
+ check=`sh -c "locale >/dev/null" 2>&1`
+ if test -n "$check" ; then
+ eval ${name}=${save}
+ eval export ${name}
+
+ echo "$whoami tried to use locale $value by setting \$$name" >&2
+ xmessage -file - <<EOF
+$whoami tried unsuccessfully to use locale $value
+by setting \$$name to "${value}".
+EOF
+ exit 1
+ fi
+ fi
+fi
+
+# for testing:
+#test -f ./xterm && XTERM_PROGRAM=./xterm
+
+exec $XTERM_PROGRAM -class KOI8RXTerm -title $whoami -k8 "$@"
diff --git a/app/xterm/koi8rxterm.man b/app/xterm/koi8rxterm.man
new file mode 100644
index 000000000..169df49fe
--- /dev/null
+++ b/app/xterm/koi8rxterm.man
@@ -0,0 +1,97 @@
+.\" $XTermId: koi8rxterm.man,v 1.3 2007/12/30 15:46:00 tom Exp $
+.\"
+.\" Copyright 2004 Branden Robinson
+.\"
+.\" Permission is hereby granted, free of charge, to any person obtaining a
+.\" copy of this software and associated documentation files (the "Software"),
+.\" to deal in the Software without restriction, including without limitation
+.\" the rights to use, copy, modify, merge, publish, distribute, sublicense,
+.\" and/or sell copies of the Software, and to permit persons to whom the
+.\" Software is furnished to do so, subject to the following conditions:
+.\"
+.\" The above copyright notice and this permission notice shall be included in
+.\" all copies or substantial portions of the Software.
+.\"
+.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+.\" IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+.\" FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+.\" SOFTWARE IN THE PUBLIC INTEREST, INC. BE LIABLE FOR ANY CLAIM, DAMAGES OR
+.\" OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
+.\" ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+.\" DEALINGS IN THE SOFTWARE.
+.TH koi8rxterm 1 "2004-12-19" "Debian Project"
+.SH NAME
+koi8rxterm \- X terminal emulator for KOI8-R environments
+.SH SYNOPSIS
+.B koi8rxterm
+[
+.I xterm-options
+]
+.SH DESCRIPTION
+.B koi8rxterm
+is a wrapper around the
+.BR xterm(1)
+program that invokes the latter program with the \(oqKOI8RXTerm\(cq X
+resource class set.
+All arguments to
+.B koi8rxterm
+are passed to
+.B xterm
+without processing; the
+.B \-class
+and
+.B \-k8
+options should not be specified because they are used by the wrapper.
+See the
+.BR xterm
+manual page for more information on
+.IR xterm-options .
+.PP
+The environment's locale settings (see \(lqENVIRONMENT\(rq below) are
+used to discern the locale's character set.
+If no current locale can be determined, the locale \(oqru_RU.KOI8-R\(cq
+(the Russian language as used in the territory of Russia, with the KOI8-R
+character set) is assumed.
+The
+.BR locale(1)
+utility is used to determine whether the system supports the selected
+locale.
+If it does not,
+.B koi8rxterm
+will exit with an error and report the output of
+.BR locale .
+.PP
+.B Note: koi8rxterm
+may produce unexpected results if the current locale is set to one in which
+the KOI8-R character encoding is not supported, or if fonts using that
+encoding are not available.
+In the Debian system, the \(oqxfonts\-cyrillic\(cq package provides the
+fonts that
+.B koi8rxterm
+uses by default.
+To change the fonts
+.B koi8rxterm
+uses, edit the
+.I __apploaddir__/KOI8RXTerm
+file.
+.PP
+A similar wrapper,
+.BR uxterm(1),
+is available for Unicode UTF-8 environments.
+.SH ENVIRONMENT
+.TP
+.B LC_ALL\fR, \fBLC_CTYPE\fR, \fBLANG
+The values of these variables are checked, in order, to determine the
+character set used by the current locale.
+.SH AUTHOR
+.B koi8rxterm
+was written by Branden Robinson and is very heavily based on
+.BR uxterm ,
+by Thomas Dickey.
+The assistance of Jurij Smakov was invaluable in sanity-checking its
+operation.
+.SH "SEE ALSO"
+.BR locale(1),
+.BR locale(7),
+.BR uxterm(1),
+.BR xterm(1)
diff --git a/app/xterm/uxterm.man b/app/xterm/uxterm.man
new file mode 100644
index 000000000..c9e4cf084
--- /dev/null
+++ b/app/xterm/uxterm.man
@@ -0,0 +1,91 @@
+.\" $XTermId: uxterm.man,v 1.3 2007/12/30 15:55:21 tom Exp $
+.\"
+.\" Copyright 2001, 2004 Branden Robinson
+.\"
+.\" Permission is hereby granted, free of charge, to any person obtaining a
+.\" copy of this software and associated documentation files (the "Software"),
+.\" to deal in the Software without restriction, including without limitation
+.\" the rights to use, copy, modify, merge, publish, distribute, sublicense,
+.\" and/or sell copies of the Software, and to permit persons to whom the
+.\" Software is furnished to do so, subject to the following conditions:
+.\"
+.\" The above copyright notice and this permission notice shall be included in
+.\" all copies or substantial portions of the Software.
+.\"
+.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+.\" IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+.\" FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+.\" SOFTWARE IN THE PUBLIC INTEREST, INC. BE LIABLE FOR ANY CLAIM, DAMAGES OR
+.\" OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
+.\" ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+.\" DEALINGS IN THE SOFTWARE.
+.TH uxterm 1 "2004-12-19" "Debian Project"
+.SH NAME
+uxterm \- X terminal emulator for Unicode (UTF-8) environments
+.SH SYNOPSIS
+.B uxterm
+[
+.I xterm-options
+]
+.SH DESCRIPTION
+.B uxterm
+is a wrapper around the
+.BR xterm(1)
+program that invokes the latter program with the \(oqUXTerm\(cq X resource
+class set.
+All arguments to
+.B uxterm
+are passed to
+.B xterm
+without processing; the
+.B \-class
+and
+.B \-u8
+options should not be specified because they are used by the wrapper.
+See the
+.B xterm
+manual page for more information on
+.IR xterm-options .
+.PP
+The environment's locale settings (see \(lqENVIRONMENT\(rq below) are
+used to discern the locale's character set.
+If no current locale can be determined, the locale \(oqen_US\(cq (the
+English language as used in the territory of the United States) is assumed.
+The
+.BR locale(1)
+utility is used to determine whether the system supports the selected
+locale.
+If it does not,
+.B uxterm
+will exit with an error and report the output of
+.BR locale .
+.PP
+.B Note: uxterm
+may produce unexpected results if the current locale is set to one in which
+the UTF-8 character encoding is not supported, or if fonts using the ISO
+10646-1 character set are not available.
+In the Debian system, the \(oqxfonts\-base\(cq package provides the fonts
+that
+.B uxterm
+uses by default.
+To change the fonts
+.B uxterm
+uses, edit the
+.I __apploaddir__/UXTerm
+file.
+.PP
+A similar wrapper,
+.BR koi8rxterm(1),
+is available for KOI8-R environments.
+.SH ENVIRONMENT
+.TP
+.B LC_ALL\fR, \fBLC_CTYPE\fR, \fBLANG
+The values of these variables are checked, in order, to determine the
+character set used by the current locale.
+.SH AUTHOR
+Thomas Dickey
+.SH "SEE ALSO"
+.BR locale(1),
+.BR locale(7),
+.BR koi8rxterm(1),
+.BR xterm(1)